# PipeLink Protocol


## Binary Frame Specification


Size | Type | Key | Descriptin
---|---|---|---
`1b` | uint8 | `version` | The protocol version, "0" for this spec
`1b` | uint8 | `flags` |
`2b` | uint16 | `len` | Length of paylload
*len* | byte* | `payload` | The message payload (json frame)

## JSON Frame Specification

```json
{
    "type": "message.type",
    "mid": "message-id",
    "attr": {
        "attribute": "Value"
    },
    "body": {
        "The frame data"
    }
}
```

Key | Type | Description | Req
---|---|---|---
type | `string` | The message type | Yes
mid | `string` | Message id | \-
rid | `string` | Response to message id | \-
attr | `array<string,any>` | Message attributes | \-
body | `any` | The frame body | Yes
