<?php

require_once __DIR__."/../vendor/autoload.php";

use NoccyLabs\PipeLink\Link;
use NoccyLabs\PipeLink\Message;

// Create a link using the STDIN and STDOUT pipes
$uplink = Link::createFromPipes(STDIN,STDOUT);

// Add a handler to process incoming messages
$uplink->addInputHandler(function (Message $message) {

    if (!$message->hasAttribute("origin")) {
        $message->setAttribute("origin", "_uplink_");
    }

});

$message = $uplink->readMessage(true);

var_dump($message);
